<!doctype html>
<html lang="en">
<head>
  <title>Thingy-52</title>
  <meta name="description" content="">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="x-ua-compatible" content="ie=edge">
  <meta charset="utf-8">

  <meta http-equiv="Cache-Control" content="no-cache, no-store, must-revalidate" />
  <meta http-equiv="Pragma" content="no-cache" />
  <meta http-equiv="Expires" content="0" />

</head>
  <body>
    <p>we need a user gesture on the page to connect</p>
    <p>
      <button name="btnConnect">Connect</button>
    </p>
    <p>
      <button name="btnStartTemperature">Temperature [Start]</button>
      <button name="btnStopTemperature">Temperature [Stop]</button>
    </p>

    <p>
      <button name="btnLedInformation">LED Information</button>
      <button name="btnLedBreatheBlue">Breathe 🔵</button>
      <button name="btnLedBreatheRed">Breathe 🔴</button>
      <button name="btnLedBreatheGreen">Breathe 🟢</button>
    </p>

    <p>
      <button name="btnSound1">Sound 1</button>
      <button name="btnSound2">Sound 2</button>
    </p>

  </body>


  <script type="module">
    import Thingy from "./node_modules/thingy52_web_bluetooth/js/Thingy.js"

    const thingy = new Thingy({logEnabled: true})

    async function connect(device) {
      try {
        let isConnected = await device.connect()
        let deviceName = await device.name.read()
        let battery = await device.battery.read()
        console.group("👋 Hello 😃")
        console.log("isConnected", isConnected)
        console.log("deviceName", deviceName)
        console.log("battery", battery)
      } catch (error) {
        console.error(error)
      }
    }

    async function startTemperature(device) {
      try {
        console.group("🌡 Temperature")
        device.addEventListener("temperature", data => {
          console.log(data.detail)
        })
        await device.temperature.start()
      } catch(error) {
        console.error(error)
      }
    }

    async function stopTemperature(device) {
      try {
        await device.temperature.stop()
        console.groupEnd()
      } catch(error) {
        console.error(error)
      }
    }


    async function LedInformation(device) {
      try {
        console.group("💡 LED information")
        let currentLedConfiguration = await device.led.read()
        console.log(currentLedConfiguration)
        console.groupEnd()
      } catch (error) {
        console.error(error)
      }
    }

    async function breathe(device, color, intensity, delay) {
      try {
        const newLedConfiguration = {
            mode: "breathe",
            color: color,
            intensity: intensity,
            delay: delay
        }

        await device.led.write(newLedConfiguration)
        console.log("💡 New LED configuration", newLedConfiguration)
      } catch(error) {
        console.error(error)
      }
    }

    async function sound(device, sample) {
      try {
        let config = await device.soundconfiguration.write({speakerMode: 3})
        let data = await device.speakerdata.write({"mode":3,"sample": sample})
        console.group("🔈 Sound")
        console.log(config)
        console.log(data)
        console.groupEnd()
      } catch(error) {
        console.error(error)
      }
    }

    document.querySelector("[name=btnConnect]").addEventListener("click", async _ => {
      connect(thingy)
    })

    document.querySelector("[name=btnStartTemperature]").addEventListener("click", async _ => {
      startTemperature(thingy)
    })

    document.querySelector("[name=btnStopTemperature]").addEventListener("click", async _ => {
      stopTemperature(thingy)
    })

    document.querySelector("[name=btnLedInformation]").addEventListener("click", async () => {
      LedInformation(thingy)
    })

    document.querySelector("[name=btnLedBreatheBlue]").addEventListener("click", async _ => {
      breathe(thingy, "blue", 50, 1000)
    })
    document.querySelector("[name=btnLedBreatheRed]").addEventListener("click", async _ => {
      breathe(thingy, "red", 50, 500)
    })
    document.querySelector("[name=btnLedBreatheGreen]").addEventListener("click", async _ => {
      breathe(thingy, "green", 50, 1000)
    })

    document.querySelector("[name=btnSound1]").addEventListener("click", async _ => {
      sound(thingy, 5)
    })

    document.querySelector("[name=btnSound2]").addEventListener("click", async _ => {
      sound(thingy, 6)
    })

  </script>

</html>
